obj
  fs : "fileio"
  ser : "conio"

dat
  filename long 0[18]
  
var
  long handle

pub Open(fname, mode)
  handle := fs.hopen(fname, mode)
  ifnot handle
    result := -1
  else
    bytemove(@filename, fname, strsize(fname) + 1)
    
pub Close
  if handle
    fs.hclose(handle)
  byte[@filename]~

pub Write(buffer, num)
  result := fs.hwrite(handle, buffer, num)

pub Read(buffer, num)
  result := fs.hread(handle, buffer, num)

pub Length
{{
  Only valid for files opened for reading.
}}
  if handle
    result := fs.hget_filesize(handle)
  else
    result := -1
  
pub ReadString( p, MAXLENGTH ) | ch
  repeat MAXLENGTH + 1
    ch := ReadByte
    ifnot byte[p++] := ch
      return
  abort string("ReadString: string too long")

pub ReadStringUpperCase( p, MAXLENGTH ) | ch
  repeat MAXLENGTH + 1
    ch := ReadByte
    if "a" =< ch and ch =< "z"
      ch -= constant("a" - "A")
    ifnot byte[p++] := ch
      return
  abort string("ReadStringUpperCase: string too long")

pub WriteString( p )
  Write( p, strsize(p) + 1 )
  
pub ReadNumber | ch
  repeat
    ifnot ch := ReadByte
      return
    if ch < "0" or ch > "9"
      abort string("ReadNumber: non-numeric character")
    result := result * 10 + ch - "0"

pub ReadByte : ch
  Read( @ch, 1 )

pub WriteByte( b )
  Write( @b, 1 )
  
pub ReadWord
  return ReadByte + (ReadByte << 8)

pub WriteWord( w )
  Write( @w, 2 )
        
pub ReadLong
  return ReadByte + (ReadByte << 8) + (ReadByte << 16) + (ReadByte << 24)

pub WriteLong( l )
  Write( @l, 4 )
      
pub SkipBytes( n )
  repeat while n => 32768
    Read( $8000, 32768 )
    n -= 32768
  Read( $8000, n )

pub Execute(mode) | fname, num, size, addr, i, dbase
  fname := @filename
  addr := $7080
  bytemove($7000, fname, strsize(fname) + 1)
  Close
  fname := string("loader.bin")
  if fs.popen(fname, "R")
    ser.str(string("Could not open "))
    ser.str(fname)
    ser.tx(13)
    return
  size := $8000 - addr
  num := fs.pread(addr, size)
  if num == size
    ser.str(string("File too large", 13))
    return
  repeat i from 6 to 14 step 2
    word[addr + i] += addr
  dbase := word[addr + 10]
  long[dbase]~
  long[dbase - 4] := $fff9ffff
  long[dbase - 8] := $fff9ffff
  coginit(cogid, $f004, addr + 4)
  
